/*
 * Fachlicher Schlüssel für JPA Entität
 */
package de.ivu.elect.business.person.entity;

import de.ivu.elect.jee.faces.Messages;
import java.util.function.Function;

@javax.enterprise.inject.Vetoed
public class TagTK
implements de.ivu.elect.jee.entity.tk.EntityTK, java.io.Serializable
  {

  private static final long serialVersionUID = 1L;

  private final int hashCode;

    protected final java.lang.String nameNormalisiert;
    public java.lang.String getNameNormalisiert(){
      return nameNormalisiert;
    }

  public TagTK(
java.lang.String nameNormalisiert
  ) {
    super();


      this.nameNormalisiert = nameNormalisiert;
    
hashCode = calculateHashCode();
  }

  @Override
  public int hashCode(){
    return hashCode;
  }


  protected int calculateHashCode() {
        int result = 1;
    
    
                    result = result + ((nameNormalisiert == null) ? 0 : nameNormalisiert.hashCode());
        
            
    return result;
  }

  @Override
  public boolean equals(Object obj) {
    if (this == obj) {
      return true;
    }

    if (obj == null) {
      return false;
    }

    if (hashCode()!=obj.hashCode()) {
      return false;
    }


            
    if (getClass() != obj.getClass()) {
      if (!(obj instanceof TagTK)) {
        return false;
      }

      if (!obj.getClass().isInstance(this)) {
        return obj.equals(this); // equals-Methode aus speziellerer Klasse verwenden
      }

    }

        TagTK other = (TagTK) obj;

                if (nameNormalisiert == null) {
          if (other.nameNormalisiert != null) {
            return false;
          }
        } else if (!nameNormalisiert.equals(other.nameNormalisiert)) {
          return false;
        }
        
            return true;
    
  }

  protected boolean hatAttribute() {
        return true;
      }

  @Override
  public String getEntityMessageKey() {
    return TagConstants.MESSAGE_KEY_ENTITY_EINZAHL;
  }

  @Override
  public java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> getAllEntityFieldValues() {
    java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> result = new java.util.ArrayList<>();

    result.addAll(getEntityFieldValuesForEntity());
    return result;
  }

  @Override
  public java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> getEntityFieldValuesForEntity() {
            java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> result = new java.util.ArrayList<>();

                    result.add(new de.ivu.elect.jee.entity.tk.EntityFieldValue(TagConstants.MESSAGE_KEY_ENTITY_EINZAHL, TagConstants.MESSAGE_KEY_NAME_NORM_EINZAHL, nameNormalisiert));
        
        return result;
      }


            @Override
            public String toString() {
            return "TagTK[" + toStringParameter() + "]";
            }



            protected String toStringParameter() {
            String result = ""

                                        +"nameNormalisiert="+nameNormalisiert
                        
            ;
                            return result;
            
            }

  @Override
  public String toStringLokalisiert(Messages messages) {
    return messages.getMessageForMessageKey(getEntityMessageKey()) + " ["
            + toStringLokalisiertFields(messages)
            + "]"
            ;
   }

            protected String toStringLokalisiertFields(Messages messages) {
        return ""
                                      + messages.getMessageForMessageKey(TagConstants.MESSAGE_KEY_NAME_NORM_EINZAHL) + "=" + nameNormalisiert
                                             ;
      }


            private String toStringLokalisiert(de.ivu.elect.jee.entity.tk.EntityTK entityTK, Messages messages) {
                if (entityTK != null) {
                    return entityTK.toStringLokalisiert(messages);
                }
                return null;
            }

            public static <E extends Tag> java.util.Map<TagTK, E> mappeTagNachTK(java.util.Collection<E> entities) {
                return entities.stream().collect(java.util.stream.Collectors.toMap(Tag::getTagTK, Function.<E>identity(), (u,v)-> v));
                }


                public static Function<Tag, TagTK> getTagToTKFunction() {
                return Tag::getTagTK;
                }

}
